Bug 662589 - nfs4 callback from client returned to wrong address
Summary: nfs4 callback from client returned to wrong address
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: kernel
Version: 6.0
Hardware: Unspecified
OS: Unspecified
low
medium
Target Milestone: rc
: ---
Assignee: J. Bruce Fields
QA Contact: Filesystem QE
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2010-12-13 09:39 UTC by Takuma Umeya
Modified: 2013-03-04 00:20 UTC (History)
8 users (show)

Fixed In Version: kernel-2.6.32-112.el6
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2011-05-23 20:31:48 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2011:0542 0 normal SHIPPED_LIVE Important: Red Hat Enterprise Linux 6.1 kernel security, bug fix and enhancement update 2011-05-19 11:58:07 UTC

Description Takuma Umeya 2010-12-13 09:39:22 UTC
Description of problem:
When alias IP is used by NFSv4 server, the callback from the client points to
wrong address. 

Version-Release number of selected component (if applicable):


How reproducible:
Always

Steps to Reproduce:
1. Set up NFSv4 server. Configure one of the ethernet with alias IP e.g. eth0 and eth0:0. 
2. Configure NFS client. Mount NFSv4 partition via the address assigned to eth0:0 of the server. 
3. enable rpc_debug: # echo 1 > /proc/sys/sunrpc/rpc_debug
4. On the client read files on the NFS partition. 
5. Looking at syslog shows xprt times out. 

 
Actual results:
5. The following message appears on syslog of the server:  
Dec  8 06:09:24 olive-kvm182 kernel: RPC:       created transport ffff88001b127000 with 16 slots
Dec  8 06:09:24 olive-kvm182 kernel: RPC:    70 reserved req ffff88001c178000 xid 0fef17c5
Dec  8 06:09:24 olive-kvm182 kernel: RPC:    70 xprt_connect xprt ffff88001b127000 is not connected
Dec  8 06:09:24 olive-kvm182 kernel: RPC:    70 xprt_connect_status: retrying
Dec  8 06:09:24 olive-kvm182 kernel: RPC:    70 xprt_prepare_transmit
Dec  8 06:09:24 olive-kvm182 kernel: RPC:    70 xprt_transmit(108)
Dec  8 06:09:24 olive-kvm182 kernel: RPC:    70 xmit complete
Dec  8 06:09:33 olive-kvm182 kernel: RPC:    70 xprt_timer ###<--- times out
Dec  8 06:09:33 olive-kvm182 kernel: RPC:    70 release request ffff88001c178000
Dec  8 06:10:54 olive-kvm182 kernel: RPC:       destroying transport ffff88001b127000
Dec  8 06:10:54 olive-kvm182 kernel: RPC:       disconnected transport ffff88001b127000
Dec  8 06:11:45 olive-kvm182 kernel: RPC:       disconnected transport ffff88001beaf800


Expected results:
Should not time out. 

Additional info:
nfsd4_probe_callback is not setting srcaddr. When the server sends the callback
information to the client it automatically sets the address of eth0; but this
should be of eth0:0 in above the case. This causes rpc transport not to be
closed even after its use which is likely to consume memory, although this will
eventually get collected.

Comment 7 RHEL Program Management 2011-01-07 04:20:32 UTC
This request was evaluated by Red Hat Product Management for
inclusion in the current release of Red Hat Enterprise Linux.
Because the affected component is not scheduled to be updated
in the current release, Red Hat is unfortunately unable to
address this request at this time. Red Hat invites you to
ask your support representative to propose this request, if
appropriate and relevant, in the next release of Red Hat
Enterprise Linux. If you would like it considered as an
exception in the current release, please ask your support
representative.

Comment 9 Suzanne Yeghiayan 2011-01-07 16:14:26 UTC
This request was erroneously denied for the current release of Red Hat
Enterprise Linux.  The error has been fixed and this request has been
re-proposed for the current release.

Comment 10 J. Bruce Fields 2011-01-07 16:52:17 UTC
Fix available, to be merged upstream for 2.6.38.

Comment 11 Ric Wheeler 2011-01-07 19:35:31 UTC
Can you set dev_ack if you can pull this in? thanks!

Comment 12 RHEL Program Management 2011-01-07 20:10:46 UTC
This request was evaluated by Red Hat Product Management for inclusion
in a Red Hat Enterprise Linux maintenance release. Product Management has 
requested further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed 
products. This request is not yet committed for inclusion in an Update release.

Comment 13 Aristeu Rozanski 2011-02-03 16:19:29 UTC
Patch(es) available on kernel-2.6.32-112.el6

Comment 17 errata-xmlrpc 2011-05-23 20:31:48 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2011-0542.html


Note You need to log in before you can comment on or make changes to this bug.